<?php
// Version: 2.0; SPortalAdmin

function template_main()
{
	global $context, $txt, $settings, $scripturl;

	echo '
	<form action="', $context['post_url'], '" method="post" accept-charset="', $context['character_set'], '">
		<table width="80%" border="0" cellspacing="0" cellpadding="0" class="tborder" align="center">
			<tr><td>
				<table border="0" cellspacing="0" cellpadding="4" width="100%">
					<tr class="titlebg">
						<td colspan="3">', $context['settings_title'], '</td>
					</tr>';

	// Have we got some custom code to insert?
	if (!empty($context['settings_message']))
		echo '
					<tr>
						<td class="windowbg2" colspan="3">', $context['settings_message'], '</td>
					</tr>';

	// Now actually loop through all the variables.
	foreach ($context['config_vars'] as $config_var)
	{
		echo '
					<tr class="windowbg2">';

		if (is_array($config_var))
		{
			// Show the [?] button.
			if ($config_var['help'])
				echo '
						<td class="windowbg2" valign="top" width="16"><a href="', $scripturl, '?action=helpadmin;help=', $config_var['help'], '" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt[119], '" border="0" align="top" /></a></td>';
			else
				echo '
						<td class="windowbg2"></td>';

			echo '
						<td valign="top" ', ($config_var['disabled'] ? ' style="color: #777777;"' : ''), '><label for="', $config_var['name'], '">', $config_var['label'], ($config_var['type'] == 'password' ? '<br /><i>' . $txt['admin_confirm_password'] . '</i>' : ''), '</label></td>
						<td class="windowbg2" width="50%">';

			// Show a check box.
			if ($config_var['type'] == 'check')
				echo '
							<input type="hidden" name="', $config_var['name'], '" value="0" /><input type="checkbox"', ($config_var['disabled'] ? ' disabled="disabled"' : ''), ' name="', $config_var['name'], '" id="', $config_var['name'], '" ', ($config_var['value'] ? ' checked="checked"' : ''), ' class="check" />';
			// Escape (via htmlspecialchars.) the text box.
			elseif ($config_var['type'] == 'password')
				echo '
							<input type="password"', ($config_var['disabled'] ? ' disabled="disabled"' : ''), ' name="', $config_var['name'], '[0]"', ($config_var['size'] ? ' size="' . $config_var['size'] . '"' : ''), ' value="*#fakepass#*" onfocus="this.value = \'\'; this.form.', $config_var['name'], '.disabled = false;" /><br />
							<input type="password" disabled="disabled" id="', $config_var['name'], '" name="', $config_var['name'], '[1]"', ($config_var['size'] ? ' size="' . $config_var['size'] . '"' : ''), ' />';
			// Show a selection box.
			elseif ($config_var['type'] == 'select')
			{
				echo '
							<select name="', $config_var['name'], '"', ($config_var['disabled'] ? ' disabled="disabled"' : ''), '>';
				foreach ($config_var['data'] as $option)
					echo '
								<option value="', $option[0], '"', ($option[0] == $config_var['value'] ? ' selected="selected"' : ''), '>', $option[1], '</option>';
				echo '
							</select>';
			}
			// Text area?
			elseif ($config_var['type'] == 'large_text')
			{
				echo '
							<textarea rows="', ($config_var['size'] ? $config_var['size'] : 4), '" cols="30" ', ($config_var['disabled'] ? ' disabled="disabled"' : ''), ' name="', $config_var['name'], '">', $config_var['value'], '</textarea>';
			}
			// Assume it must be a text box.
			else
				echo '
							<input type="text"', ($config_var['disabled'] ? ' disabled="disabled"' : ''), ' name="', $config_var['name'], '" value="', $config_var['value'], '"', ($config_var['size'] ? ' size="' . $config_var['size'] . '"' : ''), ' />';

			echo '
						</td>';
		}
		else
		{
			// Just show a separator.
			if ($config_var == '')
				echo '
							<td colspan="3" class="windowbg2"><hr size="1" width="100%" class="hrcolor" /></td>';
			else
				echo '
							<td colspan="3" class="windowbg2" align="center"><b>' . $config_var . '</b></td>';
		}
		echo '
					</tr>';
	}
	echo '
					</tr><tr>
						<td class="windowbg2" colspan="3" align="center" valign="middle"><input type="submit" value="', $txt[10], '"', (!empty($context['save_disabled']) ? ' disabled="disabled"' : ''), ' /></td>
					</tr>
				</table>
			</td></tr>
		</table>
		<input type="hidden" name="sc" value="', $context['session_id'], '" />
	</form>';
}

function template_block_list()
{
	global $context, $settings, $options, $scripturl, $txt;

	echo '
		<table border="0" align="center" cellspacing="1" cellpadding="4" class="bordercolor" width="100%">';

	foreach($context['sides'] as $side) {

		echo '
				<tr class="catbg3">
					<td colspan="5" align="left">
						<div style="float: left;">
							<b>' . $side['label'] . ' ', $txt['sp-blocksBlocks'], '</b> - <a href="' . $scripturl . '?action=spadmin;sa=blockadd;col=' . $side['id'] . '">(', $txt['sp-blocksCreate'], ')</a>
						</div>
					</td>
				</tr>';

		echo '
				<tr class="titlebg">';
		foreach ($context['columns'] as $column)
		{
				echo '
					<th', isset($column['width']) ? ' width="' . $column['width'] . '"' : '', '>
						', $column['label'], '
					</th>';
		}
		echo '
				</tr>';

		foreach($context['blocks'][$side['label']] as $block)
		{
			echo '
				<tr>
					<td align="left" valign="top" class="windowbg">', $block['label'], '</td>
					<td align="left" valign="top" class="windowbg2">', $txt['sp_function_' . $block['type'] . '_label'], '</td>
					<td align="center" valign="top" class="windowbg2">', $block['row'], '</td>
					<td align="center" valign="top" class="windowbg2">', $block['state'], ' ';
			if($block['row'] != 1)
				echo $block['moveup'], ' '; 
			if($block['row'] != count($context['blocks'][$side['label']]))
				echo $block['movedown'], ' ';
			echo $block['edit'], ' ', $block['delete'], '</td>
				</tr>';
		}
	}
	echo '
			<tr class="catbg3">
				<td colspan="5" align="left">
				</td>
			</tr>
		</table>';
}

function template_block_add()
{
	global $context, $settings, $options, $scripturl, $txt, $modSettings;

	echo '<br />
	<table border="0" align="center" cellspacing="1" cellpadding="4" class="tborder" width="60%">
		<tr class="catbg">
			<td>', $txt['sp-blocksAdd'], '</td>
		</tr><tr class="windowbg2">
			<td align="center">
				<form action="', $scripturl, '?action=spadmin;sa=blockadd" method="post" accept-charset="', $context['character_set'], '">
					<table cellpadding="4">
						<tr>
							<th align="right">', $txt['sp-blocksLabel'], ':</th>
							<td align="left"><input type="text" name="block_label" value="" size="30" /></td>
						</tr>';
				$counter = 0;
				$parameters = $context['parameters'];
				while($parameters != 0) {

					$counter = $counter + 1;

					echo '
						<tr>
							<th align="right" valign="middle">', $txt['sp-blocksParameter'], ' ' . $counter . ':</th>
							<td align="left">
								<input type="text" name="parameters[]" value="" size="10" />
							</td>
						</tr>';
					$parameters = $parameters - 1;
				}
				if(in_array($context['block_type'], array('sp_bbc', 'sp_html', 'sp_php')))
					echo '
						<tr>
							<th align="right" valign="middle">', $txt['sp-blocksContent'], ':</th>
							<td align="left">
								<textarea name="block_content" cols="50" rows="3"></textarea>
							</td>
						</tr>';
				if(empty($context['column']))
					echo '
						<tr>
							<th align="right">', $txt['sp-blocksColumn'], ':</th>
							<td align="left">
								<select id="block_column" name="block_column">
									<option value="1">', $txt['sp-positionLeft'], '</option>
									<option value="2">', $txt['sp-positionMiddleTop'], '</option>
									<option value="3">', $txt['sp-positionMiddleBottom'], '</option>
									<option value="4">', $txt['sp-positionRight'], '</option>
								</select>
							</td>
						</tr>';
				if(!empty($context['column']))
					echo '
						<input type="hidden" name="block_column" value="', $context['column'], '" />';
				if(!empty($context['column']) && !empty($context['list_blocks'])) {
					echo '
						<tr>
							<th align="right">', $txt['sp-blocksRow'], ':</th>
							<td align="left">
								<select id="order" name="placement">
									<option value="before">', $txt['sp-placementBefore'], '...</option>
									<option value="after">', $txt['sp-placementAfter'], '...</option>
								</select>
								<select id="block_row" name="block_row">';
								foreach($context['list_blocks'] as $block) {
									echo '
									<option value="' . $block['row'] . '">' . $block['label'] . '</option>';
								}
								echo '
								</select>
							</td>
						</tr>';
				}
				echo '
						<tr>
							<th align="right">', $txt['sp-blocksActive'], ':</th>
							<td align="left"><input type="checkbox" name="block_active" value="1" id="block_active" checked="checked" /></td>
						</tr>';
				if(!empty($context['parameters']))
					echo '
						<tr class="bordercolor">
							<td align="left" colspan="2" class="windowbg">', $txt['sp_function_' . $context['block_type'] . '_param'], '</td>
						</tr>';
				echo '
						<tr>
							<td colspan="2" align="center"><input type="submit" name="add_block" value="', $txt['sp-blocksAdd'], '" /></td>
						</tr>
					</table>
					<input type="hidden" name="block_type" value="', $context['block_type'], '" />
					<input type="hidden" name="sc" value="', $context['session_id'], '" />
				</form>
			</td>
		</tr>';
}

function template_block_edit()
{
	global $context, $settings, $options, $scripturl, $txt, $modSettings;

	echo '<br />
	<table border="0" align="center" cellspacing="1" cellpadding="4" class="tborder" width="60%">
		<tr class="catbg">
			<td>', $txt['sp-blocksEdit'], '</td>
		</tr><tr class="windowbg2">
			<td align="center">
				<form action="', $scripturl, '?action=spadmin;sa=blockedit" method="post" accept-charset="', $context['character_set'], '">
					<table cellpadding="4">
						<tr>
							<th align="right">', $txt['sp-blocksLabel'], ':</th>
							<td align="left"><input type="text" name="block_label" value="', $context['block_info']['label'], '" size="30" /></td>
						</tr>';
				$counter = 0;
				$parameters = $context['parameters'];
				while($parameters != 0) {

					$counter = $counter + 1;

					echo '
						<tr>
							<th align="right" valign="middle">', $txt['sp-blocksParameter'], ' ' . $counter . ':</th>
							<td align="left">
								<input type="text" name="parameters[]" value="' . trim($context['parameter_values'][$counter - 1], ' ') . '" size="10" />
							</td>
						</tr>';
					$parameters = $parameters - 1;
				}
				if(in_array($context['block_info']['type'], array('sp_bbc', 'sp_html', 'sp_php')))
					echo '
						<tr>
							<th align="right" valign="middle">', $txt['sp-blocksContent'], ':</th>
							<td align="left">
								<textarea name="block_content" cols="50" rows="3">', $context['block_info']['content'], '</textarea>
							</td>
						</tr>';
				if(!empty($context['list_blocks'])) {
					echo '
						<tr>
							<th align="right">', $txt['sp-blocksRow'], ':</th>
							<td align="left">
								<select id="order" name="placement" onchange="this.form.block_row.disabled = this.options[this.selectedIndex].value == \'\';">
									<option value="nochange">', $txt['sp-placementUnchanged'], '</option>
									<option value="before">', $txt['sp-placementBefore'], '...</option>
									<option value="after">', $txt['sp-placementAfter'], '...</option>
								</select>
								<select id="block_row" name="block_row" disabled="disabled">';
								foreach($context['list_blocks'] as $block) {
									if($block['id'] != $context['block_info']['id'])
										echo '
										<option value="' . $block['row'] . '">' . $block['label'] . '</option>';
								}
								echo '
								</select>
							</td>
						</tr>';
				}
				echo '
						<tr>
							<th align="right">', $txt['sp-blocksActive'], ':</th>
							<td align="left"><input type="checkbox" name="block_active" value="1" id="block_active"', !empty($context['block_info']['state']) ? 'checked="checked"' : '', ' /></td>
						</tr>';
				if(!empty($context['parameters']))
					echo '
						<tr class="bordercolor">
							<td align="left" colspan="2" class="windowbg">', $txt['sp_function_' . $context['block_info']['type'] . '_param'], '</td>
						</tr>';
				echo '
						<tr>
							<td colspan="2" align="right"><input type="submit" name="add_block" value="', $txt['sp-blocksEdit'], '" /></td>
						</tr>
					</table>
					<input type="hidden" name="block_column" value="', $context['block_info']['column'], '" />
					<input type="hidden" name="block_type" value="', $context['block_info']['type'], '" />
					<input type="hidden" name="block_id" value="', $context['block_info']['id'], '" />
					<input type="hidden" name="sc" value="', $context['session_id'], '" />
				</form>
			</td>
		</tr>';
}

function template_block_select_type()
{
	global $context, $settings, $options, $scripturl, $txt, $modSettings;

	echo '<br />
	<table border="0" align="center" cellspacing="1" cellpadding="4" class="tborder" width="80%">
		<tr class="catbg">
			<td>', $txt['sp-blocksSelectType'], '</td>
		</tr><tr class="windowbg">
			<td align="center">
				<form action="', $scripturl, '?action=spadmin;sa=blockadd" method="post" accept-charset="', $context['character_set'], '">
					<table cellpadding="4">';

	$row_check = 0;
	$function_count = 0;

	foreach($context['block_types'] as $type) {

		$function_count = $function_count + 1;

		if($row_check == 0)
			echo '
						<tr>';
		echo '
							<td width="190px" valign="top" class="windowbg2">
								<input type="radio" name="selected_type[]" value="', $type['function'], '" id="', $type['function'], '" onclick="updateStatus();" class="check" />&nbsp;&nbsp;<label for="', $type['function'], '"><b>', $txt['sp_function_' . $type['function'] . '_label'], '</b></label><br /><br />
								<span class="smalltext">', $txt['sp_function_' . $type['function'] . '_desc'], '<br /><br />', $txt['sp-blocksParameters'], ': ', $type['parameter'], '</span>
							</td>';
		$row_check = $row_check + 1;
		if($row_check == 3) {
			echo '
						</tr>';
			$row_check = 0;
		}
	}			

	if($function_count % 3 != 0) {

		$empty_cells = 3 - ($function_count % 3);

		while($empty_cells > 0) {

		echo '
							<td class="windowbg2">
								&nbsp;
							</td>';
		$empty_cells = $empty_cells - 1;
		}
		
			echo '
						<tr>';
	}
				if(!empty($context['column']))
					echo '
						<input type="hidden" name="block_column" value="', $context['column'], '" />';
				echo '
						<tr>
							<td colspan="3" align="center"><input type="submit" name="select_type" value="', $txt['sp-blocksSelectType'], '" /></td>
						</tr>
					</table>
					<input type="hidden" name="sc" value="', $context['session_id'], '" />
				</form>
			</td>
		</tr>';
}

function template_category_list()
{
	global $context, $settings, $options, $scripturl, $txt;

	echo '
		<table border="0" align="center" cellspacing="1" cellpadding="4" class="bordercolor" width="100%">
			<tr class="catbg3">
				<td colspan="5" align="left">
					<div style="float: left;">
						<b>', $txt['sp-categoriesCategories'], '</b>
					</div>
				</td>
			</tr>';

	echo '
			<tr class="titlebg">';
	foreach ($context['columns'] as $column)
	{
			echo '
				<th', isset($column['width']) ? ' width="' . $column['width'] . '"' : '', '>
					', $column['label'], '
				</th>';
	}
	echo '
			</tr>';

	foreach($context['categories'] as $category)
	{
		echo '
			<tr>
				<td align="center" valign="top" class="windowbg">', !empty($category['picture']['href']) ? $category['picture']['image'] : '', '</td>
				<td align="left" valign="middle" class="windowbg2">', $category['name'], '</td>
				<td align="center" valign="middle" class="windowbg2">', $category['articles'], '</td>
				<td align="center" valign="middle" class="windowbg2"><a href="' . $scripturl . '?action=spadmin;sa=statechange;id=' . $category['id'] . ';type=category;sesc=' . $context['session_id'] . '">', empty($category['publish']) ? $txt['sp-stateNo'] : $txt['sp-stateYes'], '</a></td>
				<td align="center" valign="middle" class="windowbg2">', $category['edit'], $category['delete'], '</td>
			</tr>';
	}
	echo '
			<tr class="catbg3">
				<td colspan="5" align="left">
				</td>
			</tr>
		</table>';
}

function template_category_add()
{
	global $context, $settings, $options, $scripturl, $txt, $modSettings;

	echo '<br />
	<table border="0" align="center" cellspacing="1" cellpadding="4" class="tborder" width="60%">
		<tr class="catbg">
			<td>', $txt['sp-categoriesAdd'], '</td>
		</tr>
		<tr class="windowbg2">
			<td align="center">
				<form action="', $scripturl, '?action=spadmin;sa=categoryadd" method="post" accept-charset="', $context['character_set'], '">
					<table cellpadding="4">
						<tr>
							<th align="right">', $txt['sp-categoriesName'], ':</th>
							<td align="left"><input type="text" name="category_name" value="" size="20" /></td>
						</tr><tr>
							<th align="right">', $txt['sp-categoriesPicture'], ':</th>
							<td align="left"><input type="text" name="picture_url" value="" size="30" /></td>
						</tr><tr>
							<th align="right">', $txt['sp-categoriesPublish'], ':</th>
							<td align="left"><input type="checkbox" name="show_on_index" value="1" id="show_on_index" checked="checked" /></td>
						</tr><tr>
							<td colspan="2" align="right"><input type="submit" name="add_category" value="', $txt['sp-categoriesAdd'], '" /></td>
						</tr>
					</table>
				<input type="hidden" name="sc" value="', $context['session_id'], '" />
				</form>
			</td>
		</tr>
	</table>';
}

function template_category_edit()
{
	global $context, $settings, $options, $scripturl, $txt, $modSettings;

	echo '<br />
	<table border="0" align="center" cellspacing="1" cellpadding="4" class="tborder" width="60%">
		<tr class="catbg">
			<td>', $txt['sp-categoriesEdit'], '</td>
		</tr>
		<tr class="windowbg2">
			<td align="center">
				<form action="', $scripturl, '?action=spadmin;sa=categoryedit" method="post" accept-charset="', $context['character_set'], '">
					<table cellpadding="4">
						<tr>
							<th align="right">', $txt['sp-categoriesName'], ':</th>
							<td align="left"><input type="text" name="category_name" value="', $context['category_info']['name'], '" size="20" /></td>
						</tr><tr>
							<th align="right">', $txt['sp-categoriesPicture'], ':</th>
							<td align="left"><input type="text" name="picture_url" value="', $context['category_info']['picture']['href'], '" size="30" /></td>
						</tr><tr>
							<th align="right">', $txt['sp-categoriesPublish'], ':</th>
							<td align="left"><input type="checkbox" name="show_on_index" value="1" id="show_on_index"', !empty($context['category_info']['publish']) ? ' checked="checked"' : '', ' /></td>
						</tr><tr>
							<td colspan="2" align="right"><input type="submit" name="add_category" value="', $txt['sp-categoriesEdit'], '" /></td>
						</tr>
					</table>
				<input type="hidden" name="category_id" value="', $context['category_info']['id'], '" />
				<input type="hidden" name="sc" value="', $context['session_id'], '" />
				</form>
			</td>
		</tr>
	</table>';
}

function template_category_delete()
{
	global $context, $settings, $options, $scripturl, $txt, $modSettings;

	echo '<br />
	<table border="0" align="center" cellspacing="1" cellpadding="4" class="tborder" width="60%">
		<tr class="catbg">
			<td>', $txt['sp-categoriesDelete'], '</td>
		</tr>
		<tr class="windowbg2">
			<td align="center">
				<form action="', $scripturl, '?action=spadmin;sa=categorydelete" method="post" accept-charset="', $context['character_set'], '">
					<table cellpadding="4">
						<tr>
							<td colspan="2" align="center">';
							printf($txt['sp-categoriesDeleteCount'], $context['category_info']['articles']);
	echo '<br />', !empty($context['list_categories']) ? $txt['sp-categoriesDeleteOption1'] : $txt['sp-categoriesDeleteOption2'], '</td>
						</tr>';
	if(!empty($context['list_categories'])) {
		echo '
						<tr>
							<th align="right">', $txt['sp-categoriesMove'], ':</th>
							<td align="left"><input type="checkbox" name="category_move" value="1" id="category_move" checked="checked" /></td>
						</tr>
						<tr>
							<th align="right">', $txt['sp-categoriesMoveTo'], ':</th>
							<td align="left"><select id="category_move_to" name="category_move_to">';
								foreach($context['list_categories'] as $category) {
									if($category['id'] != $context['category_info']['id'])
										echo '
										<option value="' . $category['id'] . '">' . $category['name'] . '</option>';
								}
								echo '
								</select></td>
						</tr>';
	}
	echo '
						<tr>
							<td colspan="2" align="center"><input type="submit" name="delete_category" value="', $txt['sp-categoriesDelete'], '" /></td>
						</tr>
					</table>
				<input type="hidden" name="category_id" value="', $context['category_info']['id'], '" />
				<input type="hidden" name="sc" value="', $context['session_id'], '" />
				</form>
			</td>
		</tr>
	</table>';
}

function template_article_list()
{
	global $context, $settings, $options, $scripturl, $txt, $modSettings;

	echo '
	<form action="', $scripturl, '?action=spadmin;sa=articlelist" method="post" accept-charset="', $context['character_set'], '" onsubmit="return confirm(\'', $txt['sp-articlesConfirm'], '\');">
		<table border="0" align="center" cellspacing="1" cellpadding="4" class="bordercolor" width="100%">
			<tr class="catbg3">
				<td colspan="8"><b>', $txt[139], ':</b> ', $context['page_index'], '</td>
			</tr><tr class="titlebg">';
	foreach ($context['columns'] as $column)
	{
		if ($column['selected'])
			echo '
				<th', isset($column['width']) ? ' width="' . $column['width'] . '"' : '', '>
					<a href="', $column['href'], '">', $column['label'], '&nbsp;<img src="', $settings['images_url'], '/sort_', $context['sort_direction'], '.gif" alt="" /></a>
				</th>';
		elseif ($column['sortable'])
			echo '
				<th', isset($column['width']) ? ' width="' . $column['width'] . '"' : '', '>
					', $column['link'], '
				</th>';
		else
			echo '
				<th', isset($column['width']) ? ' width="' . $column['width'] . '"' : '', '>
					', $column['label'], '
				</th>';
	}
	echo '
				<th><input type="checkbox" class="check" onclick="invertAll(this, this.form);" /></th>
			</tr>';

	while ($article = $context['get_article']())
	{
		echo '
			<tr>
				<td align="left" valign="top" class="windowbg">', $article['topic']['link'], '</td>
				<td align="left" valign="top" class="windowbg">', $article['board']['link'], '</td>
				<td align="center" valign="top" class="windowbg">', $article['poster']['link'], '</td>
				<td align="center" valign="top" class="windowbg">', $article['message']['time'], '</td>
				<td align="left" valign="top" class="windowbg">', $article['category']['name'], '</td>
				<td align="center" valign="top" class="windowbg"><a href="' . $scripturl . '?action=spadmin;sa=statechange;id=' . $article['article']['id'] . ';type=article;sesc=' . $context['session_id'] . '">', empty($article['article']['approved']) ? $txt['sp-stateNo'] : $txt['sp-stateYes'], '</a></td>
				<td align="center" valign="top" class="windowbg">', $article['edit'], $article['delete'], '</td>
				<td align="center" valign="top" class="windowbg2"><input type="checkbox" name="remove[]" value="', $article['article']['id'], '" class="check" /></td>
			</tr>';
	}
	echo '
			<tr class="catbg3">
				<td colspan="8" align="left">
					<div style="float: left;">
						<b>', $txt[139], ':</b> ', $context['page_index'], '
					</div>
					<div style="float: right;">
						<input type="submit" name="removeArticles" value="', $txt['sp-articlesRemove'], '" />
					</div>
				</td>
			</tr>
		</table>
		<input type="hidden" name="sc" value="', $context['session_id'], '" />
	</form>';
}

function template_article_add()
{
	global $context, $settings, $options, $txt, $scripturl;

	echo '
		<form action="' . $scripturl . '?action=spadmin;sa=articleadd;targetboard=' . $context['target_board'] . '" method="post" accept-charset="', $context['character_set'], '">
			<table border="0" width="540" cellspacing="1" class="bordercolor" cellpadding="4" align="center">
				<tr class="catbg3">
					<td>', $txt['sp-articlesAdd'], '</td>
				</tr>
				<tr>
					<td class="windowbg" align="center">', $txt['sp-articlesCategory'], ':
					<select id="category" name="category">';
								foreach($context['list_categories'] as $category) {
									echo '
									<option value="' . $category['id'] . '">' . $category['name'] . '</option>';
								}
								echo '
					</select></td>
				</tr>
				<tr>
					<td colspan="2" class="titlebg">
						<table cellpadding="0" cellspacing="0" border="0"><tr>
							<td><b>' . $txt[139] . ':</b> ' . $context['page_index'] . '</td>
						</tr></table>
					</td>
				</tr>
				<tr>
					<td class="windowbg" valign="middle" align="center">
						<table border="0">
							<tr>';

	if (!empty($context['boards']) && count($context['boards']) > 1)
	{
		echo '
								<td align="right"><br /><b>', $txt['smf82'], ':</b></td>
								<td align="left">
									<br />
									<select name="targetboard" onchange="this.form.submit();">';
		foreach ($context['boards'] as $board)
			echo '
										<option value="', $board['id'], '"', $board['id'] == $context['target_board'] ? ' selected="selected"' : '', '>', $board['category'], ' - ', $board['name'], '</option>';
		echo '
									</select><noscript><input type="submit" value="', $txt['sp-articlesAdd'], '" /></noscript>
								</td>';
	}

	echo '
							</tr><tr>
								<td align="right" valign="top"><br /><b>', $txt[64], ':</b></td>
								<td align="left" style="white-space: nowrap;">
									<br />
									<table>';

	foreach ($context['topics'] as $topic)
		echo '
										<tr>
											<td align="center" valign="top" class="windowbg">
												<input type="checkbox" name="articles[]" value="', $topic['msg_id'], '" class="check" />
											</td>
											<td valign="middle" style="white-space: nowrap;">
												<a href="' . $scripturl . '?topic=' . $topic['id'] . '.0" target="_blank">' . $topic['subject'] . '</a> ' . $txt[109] . ' ' . $topic['poster']['link'] . '
											</td>
										</tr>';
	echo '
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td colspan="2" class="windowbg2" align="center">
						<input type="submit" name="createArticle" value="', $txt['sp-articlesAdd'], '" />
						<input type="hidden" name="sc" value="', $context['session_id'], '" />
					</td>
				</tr>
				<tr>
					<td colspan="2" class="titlebg">
						<table cellpadding="0" cellspacing="0" border="0"><tr>
							<td><b>' . $txt[139] . ':</b> ' . $context['page_index'] . '</td>
						</tr></table>
					</td>
				</tr>
			</table>
		</form>';
}

function template_article_edit()
{
	global $context, $settings, $options, $scripturl, $txt, $modSettings;

	echo '<br />
	<table border="0" align="center" cellspacing="1" cellpadding="4" class="tborder" width="60%">
		<tr class="catbg">
			<td>', $txt['sp-articlesEdit'], '</td>
		</tr>
		<tr class="windowbg2">
			<td align="center">
				<form action="', $scripturl, '?action=spadmin;sa=articleedit" method="post" accept-charset="', $context['character_set'], '">
					<table cellpadding="4">
						<tr>
							<th align="right">', $txt['sp-articlesCategory'], ':</th>
							<td align="left">
								<select id="category" name="category">';
								foreach($context['list_categories'] as $category) {
									echo '
									<option value="' . $category['id'] . '"' . ($context['article_info']['category']['id'] == $category['id'] ? ' selected="selected"' : '') . ' >' . $category['name'] . '</option>';
								}
								echo '
								</select>
							</td>
						</tr><tr>
							<th align="right">', $txt['sp-articlesApproved'], ':</th>
							<td align="left"><input type="checkbox" name="approved" value="1" id="approved"', !empty($context['article_info']['article']['approved']) ? ' checked="checked"' : '', ' /></td>
						</tr><tr>
							<td colspan="2" align="right"><input type="submit" name="add_article" value="', $txt['sp-articlesEdit'], '" /></td>
						</tr>
					</table>
				<input type="hidden" name="article_id" value="', $context['article_info']['article']['id'], '" />
				<input type="hidden" name="sc" value="', $context['session_id'], '" />
				</form>
			</td>
		</tr>
	</table>';
}

?>